<template lang="pug">
loader(:loading="loaded", title="Loading accounts...")
  .q-pt-md.q-mb-lg
    q-breadcrumbs
      q-breadcrumbs-el(icon="home", to="/")
      q-breadcrumbs-el(
        :label="meeting.topic",
        icon="insert_invitation",
        :to="'/' + meeting['.key']"
      )
      q-breadcrumbs-el(icon="description")
        q-btn-dropdown(
          style="font-weight: normal",
          type="a",
          label="Documents",
          no-caps,
          flat,
          :to="'/managedocs/' + meeting['.key']"
        )
          q-list
            q-item(:to="'/' + meeting['.key']")
              span Visualisation
      q-breadcrumbs-el(label="Document Preparation", icon="edit")

    .text-h4.q-pt-md Create a Shared Document

  loader(:loading="!submitting", title="Submitting your document...")
    q-expansion-item.q-my-md.bg-grey-2(
      v-model="expanded",
      q-expand-separator,
      :label="loaded && selectedGoogleAccount && googleAccs ? 'Using ' + googleAccs[selectedGoogleAccount]['name'] + ' (' + googleAccs[selectedGoogleAccount]['email'] + ')' : 'No Account Selected'",
      caption="The created document (and it's copies) will be saved to this account's Google Drive storage."
    )
      q-card.bg-grey-2(flat)
        q-card-section(horizontal)
          q-card-section.col(v-if="googleAccs && accounts.length > 1")
            q-select(
              v-model="selectedGoogleAccount",
              :options="accounts",
              label="Selected Account",
              :option-value="opt => (Object(opt) === opt && 'id' in opt ? opt.id : null)",
              emit-value,
              map-options,
              :option-label="opt => (Object(opt) === opt && 'name' in opt ? opt.name + ' ' + opt.email : '- None Selected -')"
            )
          q-card-section.col
            q-btn(
              style="margin-top: 1em",
              :loading="doingGoogleLogin",
              type="a",
              v-on:click="startGoogleLogin",
              flat,
              color="primary"
            ) Link New Account

    div(v-if="googleAccs")
      div
        .text-h5.q-pt-md Document Template

        q-input.q-my-md(
          v-model="newTitle",
          label="Document Title",
          outlined,
          :rules="[val => !!val || 'Field is required']"
        )

        div
          i Sections (e.g. workshop activities) in your document for participants to work through.

          google-doc-section(
            v-for="(n, index) in sections",
            :id="n.ref",
            :sectionNumber="index + 1",
            :canDelete="index > 0",
            :title="sections[index].data.title",
            :content="sections[index].data.content",
            :response="sections[index].data.response",
            ref="sections[index].ref",
            :key="sections[index].ref"
          )

      q-btn(type="a", v-on:click="addDocSection", flat, color="primary") Add Section

      q-btn(type="a", v-on:click="addNewDocument", color="positive") Save Document to Google Drive

    #gdoc-signin-prompt(v-else-if="!googleAccs || googleAccs === []")
      p ZoomSense needs access to a Google Account in order to create and distribute documents. Please sign in to continue:
      a.googleBtn(href="#", v-on:click="startGoogleLogin")
</template>

<script>
import GoogleDocSection from "@/components/GoogleDocSection.vue";
import { EventBus } from "@/components/event-bus.js";
import { getSessionToken } from "../../shared";
import { db, auth } from "../../db";
const meetings = db.ref("meetings");
const gdocsTokens = db.ref("gdocsTokens");
import Loader from "@/components/Loader.vue";

export default {
  name: "AddDoc",
  props: ["meetingId"],
  data() {
    return {
      // meetingId: this.$route.params.meetingId,
      meeting: {},

      existingDocId: this.$route.query.existingDoc,
      existingDoc: {},

      selectedGoogleAccount: null,
      googleAccs: null,
      submitting: false,

      newTitle: null,
      sections: [],
      loaded: false,
      expanded: false,
      doingGoogleLogin: false,
    };
  },
  created() {
    this.getSessionToken = getSessionToken;

    const user = auth.currentUser;
    if (user) {
      const uid = user.uid;

      this.$rtdbBind("meeting", meetings.child(uid).child(this.meetingId)).then(
        () => {
          // load in existing data if we're editing an existing doc
          if (this.existingDocId) {
            this.existingDoc = this.meeting.gdocs.documents[this.existingDocId];
            this.newTitle = this.existingDoc.title;
            this.selectedGoogleAccount = this.existingDoc.googleAccount;
            this.existingDoc.sections.forEach(section => {
              this.sections.push({
                type: GoogleDocSection,
                ref: this.randomNumber(),
                data: section.data,
              });
            });
          } else {
            // start with one section
            this.addDocSection();
          }
          // this.loaded = true;
        },
      );

      this.$rtdbBind("googleAccs", gdocsTokens.child(uid)).then(() => {
        if (this.accounts != null && this.accounts.length > 0) {
          this.selectedGoogleAccount = this.accounts[0].id;
        } else {
          this.selectedGoogleAccount = false;
          this.expanded = true;
        }
        this.loaded = true;
      });
    } else {
      this.$router.push("/");
    }
  },
  mounted: function () {
    EventBus.$on("delete-gdoc-section", sectionId => {
      for (var i = this.sections.length - 1; i >= 0; --i) {
        if (this.sections[i].ref == sectionId) {
          this.sections.splice(i, 1);
          break;
        }
      }
    });

    EventBus.$on("gdoc-section-dataChanged", data => {
      for (var i = this.sections.length - 1; i >= 0; --i) {
        if (this.sections[i].ref == data.id) {
          delete data.id;
          this.sections[i].data = data;
        }
      }
    });
  },
  computed: {
    accounts: function () {
      if (!this.googleAccs) return null;

      var toRet = [];

      for (const key of Object.keys(this.googleAccs)) {
        // only need basic profile info - i.e. not tokens
        //console.log(this.googleAccs)

        toRet.push({
          email: this.googleAccs[key]["email"],
          name: this.googleAccs[key]["name"],
          picture: this.googleAccs[key]["picture"],
          id: key,
        });
      }
      return toRet;
    },
  },
  methods: {
    startGoogleLogin: async function () {
      this.doingGoogleLogin = true;
      var token = await this.getSessionToken();
      const reqConfig = {
        headers: { Authorization: `Bearer ${token}` },
      };

      var currentUrl = encodeURIComponent(window.location.href);

      this.$http
        .get(
          `${process.env.VUE_APP_FB_FUNCTIONS}/googleDocsAuth?return=${currentUrl}`,
          reqConfig,
        )
        .then(googleAuthUrl => {
          window.location = googleAuthUrl.data;
        })
        .catch(error => {
          console.error("Google sign-in error", error);
        });
    },
    addNewDocument: async function () {
      if (this.newTitle == null || this.newTitle.trim() == "") {
        // window.alert("Please enter a title for your document");
        this.$q.notify({
          type: "negative",
          message: `Please enter a title for your document`,
        });
        return;
      }

      for (var i = 0; i < this.sections.length; i++) {
        var section = this.sections[i];

        if (!section.data.title || section.data.title.trim() == "") {
          // window.alert(`Please enter a title for section ${i + 1}.`);
          this.$q.notify({
            type: "negative",
            message: `Please enter a title for section ${i + 1}.`,
          });
          return;
        }
        // if (!section.data.content || section.data.content.trim() == "") {
        //   window.alert(`Please enter some content for section ${i + 1}.`);
        //   return;
        // }
      }

      var cached = this.sections;
      this.submitting = true;

      var body = {
        meetingId: this.meetingId,
        doc: {
          googleAccount: this.selectedGoogleAccount,
          title: this.newTitle,
          sections: this.sections,
        },
      };

      if (this.existingDocId) {
        body.documentId = this.existingDocId;
      }

      var token = await this.getSessionToken();
      const reqConfig = {
        headers: { Authorization: `Bearer ${token}` },
      };

      this.$http
        .post(
          `${process.env.VUE_APP_FB_FUNCTIONS}/googleDocsAddOrUpdateDocument`,
          body,
          reqConfig,
        )
        .then(() => {
          this.$router.push("/managedocs/" + this.meetingId);
        })
        .catch(error => {
          this.submitting = false;
          this.sections = cached;
          // window.alert("There was an error, please try again. \n" + error);
          this.$q.notify({
            type: "negative",
            message: `There was an error, please try again.`,
          });
          console.error("Document submission", error);
        });
    },
    addDocSection() {
      this.sections.push({
        type: GoogleDocSection,
        ref: this.randomNumber(),
        data: { response: true },
      });
    },
    randomNumber() {
      return Math.floor(Math.random() * 100000);
    },
  },
  components: {
    GoogleDocSection,
    Loader,
  },
};
</script>

<style scoped>
#title-field {
  width: 40%;
  margin-bottom: 20px;
}

#finish-btn {
  margin-top: 25px;
  width: 150px;
  background-color: green;
  color: white;
}

#gdoc-signin-prompt {
  margin-top: 50px;
}

.gdoc-loading {
  margin-top: 50px;
  width: 100%;
  text-align: center;
}
</style>